<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="fotosocial-new-post-dm">
  <template>
  </template>

  <script>
    /**
     * `fotosocial-new-post-dm`
     * data manager que agrega un nuevo post al usuario activo
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialNewPostDm extends Polymer.Element {
      static get is() { return 'fotosocial-new-post-dm'; }
      static get properties() {
        return {
          user: {
            type: String,
            value: ''
          },
          photo: {
            type: String,
            value: ''
          },
          description: {
            type: String,
            value: ''
          }
        };
      }

      savePost() {
        let fotosocial = JSON.parse(localStorage.getItem('fotosocial'));
        let user = fotosocial.users.find(user => user.user === this.user);
        user.posts !== undefined ?
            this._savePostLocalStorage(user.posts.length + 1, fotosocial) :
            this._savePostLocalStorage(1, fotosocial);
        this.dispatchEvent(new CustomEvent('add-post-success', {}));
      }

      _savePostLocalStorage(id, fotosocial) {
        let post = {
              id: this.user + id,
				      photo: this.photo,
				      description: this.description,
				      likes: [],
				      unlikes: []
            };
        let newFotosocial = fotosocial.users.map( user => {
          if (user.user === this.user) {
            if (user.posts === undefined) { 
              user.posts = []; 
            }
            user.posts.push(post);
          }
          return user;
        });
        const objNewFotosocial = { users: newFotosocial };
        localStorage.setItem('fotosocial', JSON.stringify(objNewFotosocial));
      }
    }

    window.customElements.define(FotosocialNewPostDm.is, FotosocialNewPostDm);
  </script>
</dom-module>